source parray.tcl
source stooop.tcl
namespace import stooop::*

### check that non qualified procedure invocation in derived class base class constructor arguments works

# expected output:

## a::(1,_derived) = b
## a::(1,m) = 1
## b::(1,n) = 0

## A::(2,_derived) = B
## A::(2,m) = 1
## B::(2,n) = 0

proc p {p} {error "::p invoked"}

class a {}
proc a::a {this p} {
    set a::($this,m) $p
}
proc a::~a {this} {}
class b {}
proc b::b {this p} a {[p $p]} {
    set b::($this,n) $p
}
proc b::~b {this} {}
proc b::p {p} {
    return [incr p]
}
new b 0
printArrays a:: b::

class A {
    proc A {this p} {
        set A::($this,m) $p
    }
    proc ~A {this} {}
}
class B {
    proc B {this p} A {[p $p]} {
        set B::($this,n) $p
    }
    proc ~B {this} {}
    proc p {p} {
        return [incr p]
    }
}
new B 0
printArrays A:: B::
